<template>
  <el-card shadow="never" class="aui-card--fill">
    <div class="mod-sys__user">
      <search-bar :formConfigs="formConfig" ref="searchBarForm" @headBtnClick="buttonClick" />
      <base-table
        :table-props="tableProps"
        :page="listQuery.page"
        :limit="listQuery.limit"
        :table-data="tableData"
      >
        <method-btn
          v-if="tableBtn.length"
          slot="handleBtn"
          :width="80"
          label="操作"
          :method-list="tableBtn"
          @clickBtn="handleClick"
        />
      </base-table>
      <pagination
        :limit.sync="listQuery.limit"
        :page.sync="listQuery.page"
        :total="listQuery.total"
        @pagination="getDataList"
      />
      <!-- 弹窗, 新增 / 修改 -->
      <base-dialog
        :dialogTitle="addOrEditTitle"
        :dialogVisible="addOrUpdateVisible"
        @cancel="handleCancel"
        @confirm="handleConfirm"
        :before-close="handleCancel"
      >
        <add-or-update ref="addOrUpdate" @successSubmit="successSubmit"></add-or-update>
      </base-dialog>
    </div>
  </el-card>
</template>

<script>
import basicPage from "@/mixins/basic-page";
import AddOrUpdate from './dict-type-add-or-update'
import toDictType from './dict-type-to'
import i18n from "@/i18n";
const tableProps = [
  {
    prop: "dictName",
    label: i18n.t("dict.dictName"),
  },
  {
    prop: "dictType",
    label: i18n.t("dict.dictType"),
    subcomponent: toDictType
  },
  {
    prop: "sort",
    label: i18n.t("dict.sort"),
  },
  {
    prop: "remark",
    label: i18n.t("dict.remark"),
  },
  {
    prop: "createDate",
    label: i18n.t("dict.createDate"),
  },
];
const tableBtn = [
  {
    type: "edit",
    btnName: "编辑",
  },
  {
    type: "delete",
    btnName: "删除",
  },
];
export default {
  mixins: [basicPage],
  data() {
    return {
      urlOptions: {
        getDataListURL: "/sys/dict/type/page",
        deleteURL: "/sys/dict/type",
      },
      tableProps,
      tableBtn,
      addDeleteURL:true,
      formConfig: [
        {
          type: "input",
          label: i18n.t("dict.dictName"),
          placeholder: i18n.t("dict.dictName"),
          param: "dictName",
        },
        {
          type: "input",
          label: i18n.t("dict.dictType"),
          placeholder: i18n.t("dict.dictType"),
          param: "dictType",
        },
        {
          type: "button",
          btnName: "查询",
          name: "search",
          color: "primary",
        },
        {
          type: "button",
          btnName: "新增",
          name: "add",
          color: "primary",
          plain: true,
        },
      ],
    };
  },
  components: {
    AddOrUpdate,
  },
  methods:{
    //search-bar点击
    buttonClick(val) {
      switch (val.btnName) {
        case "search":
          this.listQuery.dictName = val.dictName;
          this.listQuery.dictType = val.dictType;
          this.listQuery.page = 1;
          this.getDataList();
          break;
        case "add":
          this.addOrEditTitle = '新增'
          this.addOrUpdateVisible = true;
          this.addOrUpdateHandle()
          break;
        default:
          console.log(val)
       }
    },
  }
};
</script>
